#include <iostream>
#include <stdexcept>

#include "tokenize.h"
#include "calculator.h"

using namespace std;


int main()
try
{
  Token_stream ts;        // provides get() and putback()
   double val = 0;
    while (cin) {
        Token t = ts.get();

        if (t.kind == 'q') break; // 'q' for quit
        if (t.kind == ';')        // ';' for "print now"
            cout << "=" << val << '\n';
        else
            ts.putback(t);
        val = expression(ts);
    }

}
catch (exception& e) {
    cerr << "error: " << e.what() << '\n';
    return 1;
}
catch (...) {
    cerr << "Oops: unknown exception!\n";
    return 2;
}
